using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using QuartzTypeLib;
using System.Runtime.InteropServices;
using dshow.Core;
namespace soundtest
{
    /* Please note that IMediaSeeking interface definition is does not included in the quartz libarary
     * So we had to define this interface explicitly. You can find its definistion in "IMediaSeeking.cs"
     * */

    public partial class Form1 : Form
    {

        enum _FilterState
        {
            State_Stopped,
            State_Paused,
            State_Running
        }

        private const int WM_NCHITTEST = 0x84;
        private const int HTCLIENT = 0x1;
        private const int HTCAPTION = 0x2;
        private const int WS_CHILD = 0x40000000;
        private const int WS_CLIPCHILDREN = 0x2000000;
        private const int WM_APP = 0x8000;
        private const int WM_GRAPHNOTIFY = WM_APP + 1;
        private const int WM_KEYDOWN = 0x0100;

        OpenFileDialog openflg = new OpenFileDialog();
        FilgraphManager mgr =null;
        IVideoWindow VideoWindow = null;
        IMediaSeeking IMSeeking=null;
        IMediaControl MediaControl=null;
        IBasicAudio BasicAudio = null;
        IMediaEventEx MEvent = null;

        Timer SeekingTimer = new Timer();
        string FilePath = "";
       
        public Form1()
        {
            InitializeComponent();
            openflg.FileOk += new CancelEventHandler(openflg_FileOk);
            SeekingTimer.Tick += new EventHandler(SeekingTimer_Tick);
            SeekingTimer.Interval = 100;
            
        }

        //This timer is used to animate the travbar indicator
        void SeekingTimer_Tick(object sender, EventArgs e)
        {
            long duration,currentpos,EQVal;
            IMSeeking.GetCurrentPosition(out currentpos);
            IMSeeking.GetDuration(out duration);
            EQVal = duration / 100;
            try
            {
                trackBar1.Value = Convert.ToInt32(currentpos / EQVal);
            }
            catch (Exception)
            {
            }
           
        }

        //Start playing the media content 
        private void button1_Click(object sender, EventArgs e)
        {
            int state;
            state = (int)_FilterState.State_Stopped;
            if ((_FilterState)state == _FilterState.State_Stopped)
            {
                mgr = new FilgraphManagerClass();
                mgr.RenderFile(FilePath);
                MediaControl = mgr as IMediaControl;
                BasicAudio = mgr as IBasicAudio;
                IMSeeking = mgr as IMediaSeeking;
                try
                {
                    VideoWindow = mgr as IVideoWindow;
                    VideoWindow.Owner = (int)panel1.Handle;
                    VideoWindow.SetWindowPosition(0,0, panel1.Width, panel1.Height);
                    VideoWindow.WindowStyle = WS_CHILD | WS_CLIPCHILDREN;
                    VideoWindow.SetWindowForeground(-1);
                }
                catch (Exception)
                {
                }
               
                MEvent = mgr as IMediaEventEx;
                MEvent.SetNotifyWindow((int)this.Handle, WM_GRAPHNOTIFY, 0);
                MediaControl.Run();
                button1.Enabled = false;
                SeekingTimer.Enabled = true;
                
                
                
            }
            else if ((_FilterState)state == _FilterState.State_Paused)
            {
                MediaControl.Run();
            }
           
        }

        //Show open file dialogbox
        private void button2_Click(object sender, EventArgs e)
        {
            openflg.ShowDialog();
        }

        void openflg_FileOk(object sender, CancelEventArgs e)
        {
            FilePath = openflg.FileName;
            try
            {
                // Stop if the media is playing
                MediaControl.StopWhenReady();
                Marshal.ReleaseComObject(mgr);
            }
            catch (Exception)
            {
                
                
            }
           
            mgr = null;
            SeekingTimer.Enabled = false;
            trackBar1.Value = 0;
            button1.Enabled = true;
           
        }

        //set the media position according to the trackbar position
        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            long duration;
            long CurrentPosition;
            IMSeeking.GetDuration(out duration);
            CurrentPosition = (duration / 100)*trackBar1.Value;
            IMSeeking.SetPositions(ref CurrentPosition, SeekingFlags.AbsolutePositioning, ref duration, SeekingFlags.NoPositioning);
            
        }

        //stop playing
        private void btnstop_Click(object sender, EventArgs e)
        {
            MediaControl.StopWhenReady();
            Marshal.ReleaseComObject(mgr);
            mgr = null;
            SeekingTimer.Enabled = false;
            trackBar1.Value = 0;
            button1.Enabled = true;
        }

        //pause playing
        private void btnpause_Click(object sender, EventArgs e)
        {
            MediaControl.Pause();
        }

        protected override void WndProc(ref Message m)
        {
            switch (m.Msg)
            {
                case WM_NCHITTEST:
                    base.WndProc(ref m);
                    if ((int)m.Result == HTCLIENT)
                        m.Result = (IntPtr)HTCAPTION;
                    return;

                case WM_GRAPHNOTIFY:
                 
                    return;
                case WM_KEYDOWN:
                  
                    return;
                   
            }

            base.WndProc(ref m);
        }

        private void panel1_DoubleClick(object sender, EventArgs e)
        {
            try
            {
                VideoWindow.FullScreenMode = 1;
            }
            catch (Exception)
            {
            }
          
        }

        private void panel1_Resize(object sender, EventArgs e)
        {
            try
            {
                VideoWindow.SetWindowPosition(0, 0, panel1.Width, panel1.Height);
            }
            catch (Exception)
            {
            }
          
        }
    }
}